# remirepo/Fedora spec file for php-zendframework-zenddiagnostics
#
# Copyright (c) 2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    79d0b7d0a1cab8f18e73d76ff1c2ec028f113840
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-diagnostics
# Packagist
%global pk_vendor    %{gh_owner}
%global pk_project   zenddiagnostics
# Namespace
%global library      ZendDiagnostics
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{pk_vendor}-%{pk_project}
Version:        1.4.0
Release:        2%{?dist}
Summary:        A set of components for performing diagnostic tests

License:        BSD
URL:            https://framework.zend.com/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-pdo
BuildRequires:  php-simplexml
BuildRequires:  php-json
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-xmlreader
# From composer, "require-dev": {
#        "doctrine/migrations": "^1.0",
#        "guzzlehttp/guzzle": "^5.3.2 || ^6.3.3",
#        "mikey179/vfsStream": "^1.6",
#        "php-amqplib/php-amqplib": "^2.0",
#        "phpunit/phpunit": "^5.7.27 || 6.5.8 || ^7.1.2",
#        "predis/predis": "^1.0",
#        "sensiolabs/security-checker": "^5.0",
#        "symfony/yaml": "^2.7 || ^3.0 || ^4.0",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-loader": "^2.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-composer(doctrine/migrations)         >= 1.0   with php-composer(doctrine/migrations)         < 2)
BuildRequires: (php-composer(guzzlehttp/guzzle)           >= 5.3.2 with php-composer(guzzlehttp/guzzle)           < 7)
BuildRequires: (php-composer(mikey179/vfsStream)          >= 1.6   with php-composer(mikey179/vfsStream)          < 2)
BuildRequires: (php-composer(php-amqplib/php-amqplib)     >= 2.0   with php-composer(php-amqplib/php-amqplib)     < 3)
BuildRequires: (php-composer(predis/predis)               >= 1.0   with php-composer(predis/predis)               < 2)
BuildRequires: (php-composer(sensiolabs/security-checker) >= 5.0   with php-composer(sensiolabs/security-checker) < 6)
BuildRequires: (php-composer(symfony/yaml)                >= 2.7   with php-composer(symfony/yaml)                < 5)
%global phpunit %{_bindir}/phpunit7
# remirepo:15
%else
BuildRequires:  php-composer(doctrine/migrations)         <  2
BuildRequires:  php-composer(doctrine/migrations)         >= 1.0
BuildRequires:  php-composer(guzzlehttp/guzzle)           <  7
BuildRequires:  php-composer(guzzlehttp/guzzle)           >= 5.3.2
BuildRequires:  php-composer(mikey179/vfsStream)          <  2
BuildRequires:  php-composer(mikey179/vfsStream)          >= 1.6
BuildRequires:  php-composer(php-amqplib/php-amqplib)     <  3
BuildRequires:  php-composer(php-amqplib/php-amqplib)     >= 2.0
BuildRequires:  php-composer(predis/predis)               <  2
BuildRequires:  php-composer(predis/predis)               >= 1.0
BuildRequires:  php-composer(sensiolabs/security-checker) <  6
BuildRequires:  php-composer(sensiolabs/security-checker) >= 5.0
BuildRequires:  php-symfony3-yaml
%global phpunit %{_bindir}/phpunit
%endif
BuildRequires:  %{phpunit}
BuildRequires:  /bin/ps
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0"
Requires:       php(language) >= 5.6
#    "suggest": {
#        "ext-bcmath": "Required by Check\\CpuPerformance",
#        "sensiolabs/security-checker": "Required by Check\\SecurityAdvisory",
#        "symfony/yaml": "Required by Check\\YamlFile",
#        "guzzlehttp/guzzle": "Required by Check\\GuzzleHttpService",
#        "predis/predis": "Required by Check\\Redis",
#        "videlalvaro/php-amqplib": "Required by Check\\RabbitMQ",
#        "doctrine/migrations": "Required by Check\\DoctrineMigration"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Recommends:     php-bcmath
Recommends:    (php-composer(sensiolabs/security-checker) >= 5.0   with php-composer(sensiolabs/security-checker) < 6)
Recommends:    (php-composer(symfony/yaml)                >= 2.7   with php-composer(symfony/yaml)                < 5)
Recommends:    (php-composer(guzzlehttp/guzzle)           >= 5.3.2 with php-composer(guzzlehttp/guzzle)           < 7)
Recommends:    (php-composer(predis/predis)               >= 1.0   with php-composer(predis/predis)               < 2)
Recommends:    (php-composer(php-amqplib/php-amqplib)     >= 2.0   with php-composer(php-amqplib/php-amqplib)     < 3)
Recommends:    (php-composer(doctrine/migrations)         >= 1.0   with php-composer(doctrine/migrations)         < 2)
# remirepo:1
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.3.1
Requires:       php-pdo
Requires:       php-simplexml
Requires:       php-json
Requires:       php-pcre
Requires:       php-spl
Requires:       php-xmlreader

Provides:       php-composer(%{gh_owner}/%{pk_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{pk_project}) = %{version}


%description
Perform diagnostic tests within real-world PHP applications.


%prep
%setup -q -n %{gh_project}-%{gh_commit}
mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/SensioLabs/Security/autoload.php',
    [
        '%{php_home}/Symfony4/Component/Yaml/autoload.php',
        '%{php_home}/Symfony3/Component/Yaml/autoload.php',
        '%{php_home}/Symfony/Component/Yaml/autoload.php',
    ],
    [
        '%{php_home}/GuzzleHttp6/autoload.php',
        '%{php_home}/Guzzle/autoload.php',
    ],
    '%{php_home}/PhpAmqpLib/autoload.php',
    '%{php_home}/Doctrine/DBAL/Migrations/autoload.php',
]);
if  (file_exists('/usr/share/pear/Predis/Autoloader.php')) {
    require_once '/usr/share/pear/Predis/Autoloader.php';
    Predis\Autoloader::register();
}
EOF


%install
mkdir -p   %{buildroot}%{php_home}
cp -pr src %{buildroot}%{php_home}/%{library}



%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendDiagnosticsTest\\', dirname(__DIR__).'/test');
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/org/bovigo/vfs/autoload.php',
]);
EOF

# testJitFreeSpace have erratic results as rely on free space in builder  /tmp
# testCheck have erratic results from reviewer
# test in GuzzleHttpServiceTest.php sometime fail in local build, ok in mock

ret=0
for cmdarg in "php %{phpunit}" php71 php72 php73; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} \
      --filter '^((?!(testJitFreeSpace|testCheck)).)*$' \
      --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
# remirepo:1
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/%{library}


%changelog
* Thu Jan 10 2019 Remi Collet <remi@remirepo.net> - 1.4.0-2
- ignore tests with erratic results

* Thu Jan 10 2019 Remi Collet <remi@remirepo.net> - 1.4.0-1
- update to 1.4.0
- raise dependency on sensiolabs/security-checker 5.0

* Thu Jan  3 2019 Remi Collet <remi@remirepo.net> - 1.3.1-1
- initial package
